# PHP_API_VERSION
%global apiver  20151012
# ZEND_MODULE_API_NO
%global zendver 20151012
# PDO_DRIVER_API
%global pdover  20150127

%define phplib %{_libdir}/php
%define extdir %{phplib}/extensions
%define peardir %{_datadir}/php/pear
%define phpvar  /var/lib/php

%define allow_exec_dir 1
%define _unpackaged_files_terminate_build 0

# don't build debug package
#define debug_package %{nil}
# don't binary strip
#define __spec_install_post %{nil}

%define build_fpm 1
# php 7에서는 아직 구현 안했음. 나중 구현을 위해 남겨둠
%define php53_compatible 0

%{!?_with_no_goto:%define _vm_goto 1}
%{?_with_no_goto:%define _vm_goto 0}

Summary: The PHP HTML-embedded scripting language for use with Apache2.
Summary(ko): Apache2 PHP 엔진
Name: php
Version: 7.0.7
Release: 1%{?dist}
Epoch: 100
Group: Development/Languages
License: PHP
Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
Source2: info.php
Source3: macros.php
Source4: php-dependency.txt

Source100: pecl-extension.tar.bz2
Source101: httpd.conf
Source102: annyung_func_alias_table.php

#Source1000: zend_vm_execute.h-goto-%{version}

# patch start
# oops patch to 1 - 99
Patch1: php-ini.patch
Patch2: php-version.patch
Patch3: php-libtool2.patch
Patch4: php-5.4.16-fpm-logpath.patch

# build env patch
Patch10: php-mysql.patch
# don' use
Patch11: php-mysql-charset.patch
Patch12: php-libgd-freetype.patch
Patch13: php-dba.patch
# don' use
Patch14: php-snmp-shutdown.patch
Patch15: php-phpize64.patch
Patch16: php-includedir.patch
Patch17: php-tmpdir.patch

# new functions
Patch30: php-gd-charspace.patch
Patch31: php-annyung-exec-dir.patch
Patch32: php-annyung-alias.patch
Patch33: php-annyung-zend-listed-table.patch
# Patch 34 and Patch 35 are dependent on patch 33
Patch34: php-annyung-include-file-check.patch
# Patch 35 is dependent on Patch 34
Patch35: php-annyung-image-attack.patch
# block '\0' to path after 5.3.4RC1. still need?
# don' use
Patch36: php-annyung-urldecode-hex-null.patch
Patch37: php-annyung-realpath-cache-force.patch

# php 5.3 compatible
Patch51: php-annyung-5.3-compatible-option.patch
Patch52: php-annyung-5.3-compatible-functions.patch
Patch53: php-annyung-5.3-creative-default-object-nowarning.patch
Patch54: php-annyung-5.3-allow-call_time_pass_reference.patch
Patch55: php-annyung-5.3-magic_quotes.patch

# patch for rhel5
Patch100: php-4.3.1-odbc.patch
Patch101: php-fc-dlopen.patch
Patch103: php-5.3.18-gnusrc.patch
Patch104: php-5.3.18-systzdata-v7.patch
Patch105: php-5.3.18-embed.patch

# patch third party extension
# don' use
#Patch201: php-sqlite-php54.patch
#Patch202: php-sqlite-config.patch

# private patch
# http://wiki.ohgaki.net/index.php?PHP%2Fpatch
Patch3000: php-allow_url_fopen-INI_ALL.patch

# offcial patch
Patch5001: php-7.0.8-official-b72221.patch
Patch5002: php-7.0.8-official-b72218.patch
Patch5003: php-7.0.8-official-b72308.patch
Patch5004: php-7.0.8-official-b72337.patch
Patch5005: php-7.0.8-official-b72143.patch
Patch5006: php-7.0.8-official-b71573.patch
Patch5007: php-7.0.8-official-b72294.patch
Patch5008: php-7.0.8-official-b72284.patch
Patch5009: php-7.0.8-official-b72195.patch
Patch5010: php-7.0.8-official-b72197.patch
Patch5011: php-7.0.8-official-b72193.patch
Patch5012: php-7.0.8-official-b72369.patch
Patch5013: php-7.0.8-official-b72017.patch
Patch5014: php-7.0.8-official-b72229.patch
Patch5015: php-7.0.8-official-b72300.patch
Patch5016: php-7.0.8-official-b72258.patch
Patch5017: php-7.0.9-official-b43475.patch
Patch5018: php-7.0.9-official-b53640.patch
Patch5019: php-7.0.9-official-b72399.patch
Patch5020: php-7.0.9-official-b72405.patch
Patch5021: php-7.0.9-official-b72306.patch
Patch5022: php-7.0.9-official-b72439.patch

Patch9000: php-5.3.1-unofficial-bug-51056-fread.patch

# security
#Patch6000: php-5.5.10-CVE-2013-7345.patch


# patch end
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: webserver, php-common, libicu, bzip2-libs
Requires: openssl, zlib, libxml2
BuildRequires: readline-devel, ncurses-devel, zlib-devel, file >= 4, re2c
BuildRequires: libpng-devel, libjpeg-devel, db4-devel, gdbm-devel
#BuildRequires: openssl-devel, zlib-devel, libxml2-devel, mysql-devel
BuildRequires: openssl-devel, zlib-devel, libxml2-devel bison
BuildRequires: curl-devel, freetds-devel, freetype-devel
BuildRequires: libmcrypt-devel, mhash-devel, libicu-devel
BuildRequires: libevent-devel >= 1.4, net-snmp-devel sqlite-devel
BuildRequires: httpd-devel, openldap-devel bzip2-devel MTA
BuildRequires: imap-devel gmp-devel unixODBC-devel
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

# SEE-ASLO
# recode conflict building with imap
# oci8 conflict building with ldap

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

Building option:
	--with no_goto : if don't add vm kind option with goto..

%package cli
Group: Development/Languages
Summary: php command line interface
Summary(ko): php cli 인터페이스
Requires: php-common, readline, ncurses, zlib, openssl, libicu
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description cli
php binary file to use in shell

%package fpm
Group: Development/Languages
Summary: php7 fpm engine
Requires: php-fpm-conf, zlib, openssl, libicu, ncurses, libicu
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description fpm
php fastcgi(fpm) server api

%package devel
Group: Development/Libraries
Summary: php development file for making extensions
Summary: php 확장 개발을 위한 파일들

%description devel
php build file for making extensions

%package extension
Group: Development/Languages
Summary: php shared extension
Requires: phpapi
Requires: libjpeg, file, curl, openldap, gmp, sqlite
#Requires: sqlite, mysql-shared, freetype, freetds, libpng, libmcrypt, mhash
Requires: freetype, libpng, libmcrypt, mhash
Requires: libicu, libevent >= 1.4, net-snmp-libs
# block centos' php
Obsoletes: php-bcmath php-calendar php-curl php-exit php-fileinfo
Obsoletes: php-ftp php-gd php-gettext php-json php-ldap php-mcrypt
Obsoletes: php-mysql php-mysqli php-opcache php-pdo-mysql php-pdo-sqlite
Obsoletes: php-snmp php-soap php-sqlite3 php-xmlreader php-xmlwriter php-zip

# compatible php base package
Provides: php-bcmath php-calendar php-curl php-exit php-fileinfo
Provides: php-ftp php-gd php-gettext php-json php-ldap php-mcrypt
Provides: php-mysql php-mysqli php-opcache php-pdo-mysql php-pdo-sqlite
Provides: php-snmp php-soap php-sqlite3 php-xmlreader php-xmlwriter php-zip

%description extension
This package include php shared extension


%package dba
Group: Development/Languages
Summary: PHP dba extension
Summary(ko): PHP dba 확장
Requires: phpapi db4 gdbm

%description dba
PHP Database (dbm-style) Abstraction Layer extension


%package dblib
Group: Development/Languages
Summary: PHP pdo_dblib extension
Summary(ko): PHP dba 확장
Requires: phpapi freetds
Provides: php-pdo-dblib

%description dblib
PHP Microsoft SQL Server and Sybase Functions


%package odbc
Group: Development/Languages
Summary: PHP odbc and pdo_odbc extension
Summary(ko): PHP odbc, pdo_odbc 확장
Requires: phpapi unixODBC

%description odbc
PHP ODBC and PDO ODBC interface APIs


%package pgsql
Group: Development/Languages
Summary: PHP pgsql and pdo_pgsql extension
Summary(ko): PHP pgsql, pdo_pgsql 확장
Requires: phpapi postgresql-libs

%description pgsql
PHP pgsql and PDO PgSQL interface APIs


%prep
%setup -q -n php-%{version} -a 100

#pushd $RPM_BUILD_DIR/php-%{version} &> /dev/null
#tar xvfpj %{SOURCE100}
#popd &> /dev/null

# official patch
%patch5001 -p1
%patch5002 -p1
%patch5003 -p1
%patch5004 -p1
%patch5005 -p1
%patch5006 -p1
%patch5007 -p1
%patch5008 -p1
%patch5009 -p1
%patch5010 -p1
%patch5011 -p1
%patch5012 -p1
%patch5013 -p1
%patch5014 -p1
%patch5015 -p1
%patch5016 -p1
%patch5017 -p1
%patch5018 -p1
%patch5019 -p1
%patch5020 -p1
%patch5021 -p1
%patch5022 -p1

%patch9000 -p1

# sec
#patch6000 -p1

%patch1 -p1
%patch2 -p1
%patch3 -p1
%if %{build_fpm}
%patch4 -p1
%endif

#patch10 -p1
#patch11 -p1
%patch12 -p1
%patch13 -p1
#patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1

%patch30 -p1
%if %{allow_exec_dir}
%patch31 -p1
%endif
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
#patch36 -p1
%patch37 -p1

%if %{php53_compatible}
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p1
%patch55 -p1
%endif

# fedora patch
%patch100 -p1
%patch101 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

# private update
%patch3000 -p1

# 3rd party patch
#patch201 -p0
#patch202 -p1

# 주의!!
# httpd.conf에서 MPM이 event로 되어 있으면, ZTS로 빌드 됨!
res=$(cat /etc/httpd/conf.d/LoadModules.conf | grep "^LoadModule[[:blank:]]\+mpm_prefork" || :)
if [ "$res" = "" ]; then
	echo "MPM check: MPM is not mpm_prefork!!"
	exit 1
fi

%if %{_vm_goto}
# memory allocated를 실패하면, swapfile을 생성해서 등록해서 진행할 것!
pushd Zend
	if [ -f "/usr/bin/php" ]; then
		%{__rm} -f zend_vm_execute.h
		php zend_vm_gen.php --with-vm-kind=GOTO

		# 5.6 bug? constant_fetch_end label 중복 에러로, 파일 생성해서
		#중복 수정한 파일 이용
		#%{__rm} -f zend_vm_execute.h
		#%{__install} -m644 %{SOURCE1000} ./zend_vm_execute.h
	fi
popd
%endif

%build

BuildPHP() {
	[ ! -d "%{phpvar}/tmp" ] && mkdir -p %{phpvar}/tmp && chmod 1777 %{phpvar}/tmp
	#OOPS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing -Wno-pointer-sign"
	RPMS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing"
	export CFLAGS="-fPIC ${RPMS_FLAGS}"
	export EXTENSION_DIR=%{extdir}
	export PEAR_INSTALLDIR=%{peardir}

	case "$1" in
		cli) scandir="cli"; shift ;;
		apache) scandir="apache"; shift ;;
		fpm) scandir="fpm"; shift ;;
	esac

#		--without-pic \
	%{configure} \
		--with-libdir=%{_lib} \
		--sysconfdir=%{_sysconfdir}/php.d \
		--with-config-file-path=%{_sysconfdir}/php.d \
		--with-config-file-scan-dir=%{_sysconfdir}/php.d/$scandir \
		--disable-debug \
		--disable-opcache \
%if %{_vm_goto}
		--disable-phpdbg \
%endif
		--disable-xmlreader \
		--disable-xmlwriter \
		--disable-json \
		--without-pear \
		--without-sqlite3 \
		--with-bz2 \
		--with-zlib \
		--with-zlib-dir=%{_prefix} \
		--enable-zend-signals \
		--enable-sigchild \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-sysvmsg \
		--enable-mysqlnd \
		--enable-intl \
		--enable-soap=shared \
		--enable-pdo \
		--without-pdo-sqlite \
		--without-pdo-mysql \
		--enable-sockets \
		--enable-mbstring=all \
		--enable-mbregex \
		--enable-mbregex-backtrack \
		--with-libmbfl \
		--with-iconv \
		--with-openssl \
		--with-xmlrpc \
		--with-system-tzdata \
		--with-mysql-sock=/var/run/mysqld/mysql.sock \
		$*

	%{__make} %{?_smp_mflags}
}

%{__rm} -f configure

# aclocal workaround - to be improved
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >>aclocal.m4

# pull latest ltmain.sh, AC_PROG_LIBTOOL
# Force use of system libtool:
libtoolize --force --copy
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >build/libtool.m4
# force aclocal run during buildconf
touch acinclude.m4

./buildconf --force

# binary compile
BuildPHP cli \
		--with-exec-dir="" \
		--enable-pcntl \
		--with-readline \
		--with-ncurses \
		--enable-ncursesw \
		--disable-cgi \
		--enable-static

mv sapi/cli/php sapi/cli/php-cli
mv sapi/cli/php.1 sapi/cli/php.1.cli
%{__mkdir_p} %{buildroot}%{_bindir}
mv ext/phar/phar.phar ext/phar/phar.phar.cli

# build fastcgi module
%{__make} clean

%if %{build_fpm}
BuildPHP fpm \
		--with-exec-dir=%{phpvar}/bin \
		--enable-fpm \
		--with-fpm-systemd \
		--disable-cli \
		--enable-opcache \
		--enable-pcntl

mv sapi/fpm/php-fpm sapi/fpm/php-fpm-back
mv sapi/fpm/php-fpm.8 sapi/fpm/php-fpm.8.fpm

# build apache module
%{__make} clean
%endif

BuildPHP apache \
		--with-apxs2=/usr/bin/apxs \
		--with-exec-dir=%{phpvar}/bin \
		--disable-cli \
		--disable-cgi \
		--enable-bcmath=shared \
		--enable-calendar=shared \
		--with-curl=shared,%{_prefix} \
		--enable-dba=shared \
			--with-gdbm \
			--with-dbm \
			--with-db4 \
		--enable-exif=shared \
		--enable-fileinfo=shared \
		--enable-ftp=shared \
		--with-gd=shared \
			--enable-gd-native-ttf \
			--with-jpeg-dir=%{_prefix} \
			--with-png-dir=%{_prefix} \
			--with-freetype-dir=%{_prefix} \
		--with-gettext=shared \
		--with-gmp=shared \
		--with-imap=shared --with-imap-ssl \
		--enable-json=shared \
		--with-ldap=shared --with-ldap-sasl \
		--with-libevent=shared \
		--with-mcrypt=shared \
		--with-mysql=shared,mysqlnd \
		--with-mysqli=shared,mysqlnd \
		--enable-opcache \
		--with-pdo-dblib=shared,%{_prefix} \
		--with-pdo-mysql=shared,mysqlnd \
		--with-pdo-pgsql=shared \
		--with-pdo-odbc=shared,unixODBC,%{_prefix} \
		--with-pdo-sqlite=shared,%{_prefix} \
		--with-pgsql=shared \
		--enable-shmop=shared \
		--with-snmp=shared,%{_prefix} \
		--enable-soap=shared \
		--with-sqlite3=shared \
		--with-unixODBC=shared,%{_prefix} \
		--enable-wddx=shared \
		--enable-xmlreader=shared \
		--enable-xmlwriter=shared \
		--enable-zip=shared

cd modules
/bin/ls *.so | sed 's/^/;extension = /' > ../extensions.ini
cd -

%install
[ "%{buildroot}" != "/" -a -d "${buildroot}" ] && rm -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf
install -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

%{__make} install INSTALL_ROOT=%{buildroot} INSTALL_ID="echo "

rm -rf %{buildroot}%{extdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{extdir}
mkdir -p %{buildroot}/home/httpd/html
mkdir -p %{buildroot}%{_mandir}/{man1,man8}
mkdir -p %{buildroot}%{_sysconfdir}/php.d/{cli,apache}

install -m 755 ext/phar/phar.phar.cli %{buildroot}%{_bindir}/phar.phar
cd %{buildroot}%{_bindir}
ln -sf phar.phar phar
cd -

install -m 755 sapi/cli/php-cli %{buildroot}%{_bindir}/php
install -m 644 sapi/cli/php.1.cli %{buildroot}%{_mandir}/man1/php.1
#(cd %{buildroot}%{_bindir}; ln -sf php php5)
install -m 755 -s modules/*.so %{buildroot}%{extdir}
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php.d/php.ini
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php.d/php-cli.ini
install -m 644 %{SOURCE2} %{buildroot}/home/httpd/html/php_info.php

install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php.d/apache/shared.ini
install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php.d/cli/shared.ini


%if %{build_fpm}
%{__mkdir_p} %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_mandir}/man8
install -m 755 sapi/fpm/php-fpm-back %{buildroot}%{_sbindir}/php-fpm
install -m 644 sapi/fpm/php-fpm.8.fpm  %{buildroot}%{_mandir}/man8/php-fpm.8
%endif

%{__mkdir_p} %{buildroot}%{peardir}
install -m 644 %{SOURCE102} %{buildroot}/%{peardir}/alias_table.php

mv LICENSE LICENSE.php5

# session and update tmp dir
mkdir -p %{buildroot}%{phpvar}/{sessions,tmp,bin}

# dependency problem
pushd %{buildroot}%{phplib}/build
	chmod 644 *
	chmod 755 shtool
popd

# Generate files lists and stub .ini files for each subpackage
for mod in $(ls %{buildroot}%{extdir}/*.so)
do
	modname=$(basename $mod | sed 's/\.so//g')

	[ "${modname}" = "dba" -o "${modname}" = "pdo_dblib" ] && continue
	[ "${modname}" = "odbc" -o "${modname}" = "pdo_odbc" ] && continue
	[ "${modname}" = "pgsql" -o "${modname}" = "pdo_pgsql" ] && continue

	cat >> files.ext <<EOF
%attr(755,root,root) %{extdir}/${modname}.so
EOF
done

# Package pdo_sqlite with pdo; isolating the sqlite dependency
# isn't useful at this time since rpm itself requires sqlite.
#cat files.pdo_sqlite >> files.pdo

# Install the macros file:
install -d %{buildroot}%{_sysconfdir}/rpm
sed -e "s/@PHP_APIVER@/%{apiver}/;s/@PHP_ZENDVER@/%{zendver}/;s/@PHP_PDOVER@/%{pdover}/" \
    < $RPM_SOURCE_DIR/macros.php > macros.php
install -m 644 -c macros.php \
           %{buildroot}%{_sysconfdir}/rpm/macros.php

cd %{buildroot}%{_sysconfdir}/php.d/
for dname in apache cli
do
	cat >> ${dname}/dba.ini <<EOF
extension = dba.so
EOF

	cat >> ${dname}/dblib.ini <<EOF
extension = pdo_dblib.so
EOF

	cat >> ${dname}/odbc.ini <<EOF
extension = odbc.so
extension = pdo_odbc.so
EOF

	cat >> ${dname}/pgsql.ini <<EOF
extension = pgsql.so
extension = pdo_pgsql.so
EOF
done
cd -

# Remove unpackaged files
rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf \
       %{buildroot}%{_bindir}/{phptar} \
       %{buildroot}%{_datadir}/pear

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
rm -f files.* macros.php

%files
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/httpd/modules/libphp7.so
#{peardir}/alias_table.php
%dir %{phplib}
%dir %{phplib}/extensions
#attr(755,nobody,nobody) %dir %{phpvar}/sessions
#attr(1777,root,root) %dir %{phpvar}/tmp
#attr(755,root,root) %dir %{phpvar}/bin

%files cli
%defattr(-,root,root)
%attr(755,root,root) %{_bindir}/php
%attr(755,root,root) %{_bindir}/phar.phar
%{_bindir}/phar
%{_mandir}/man1/php.1*
#{_bindir}/php7

%if %{build_fpm}
%files fpm
%attr(755,root,root) %{_sbindir}/php-fpm
%{_mandir}/man8/php-fpm.8*
%endif

%files devel
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rpm/macros.php
%{_bindir}/php-config
%{_bindir}/phpize
%{_includedir}/php
%{_libdir}/php/build
%{_mandir}/man1/php-config.1*
%{_mandir}/man1/phpize.1*

%files extension -f files.ext

%files dba
%attr(755,root,root) %{extdir}/dba.so
%attr(644,root,root) %{_sysconfdir}/php.d/apache/dba.ini
%attr(644,root,root) %{_sysconfdir}/php.d/cli/dba.ini

%files dblib
%attr(755,root,root) %{extdir}/pdo_dblib.so
%attr(644,root,root) %{_sysconfdir}/php.d/apache/dblib.ini
%attr(644,root,root) %{_sysconfdir}/php.d/cli/dblib.ini

%files odbc
%attr(755,root,root) %{extdir}/odbc.so
%attr(755,root,root) %{extdir}/pdo_odbc.so
%attr(644,root,root) %{_sysconfdir}/php.d/apache/odbc.ini
%attr(644,root,root) %{_sysconfdir}/php.d/cli/odbc.ini

%files pgsql
%attr(755,root,root) %{extdir}/pgsql.so
%attr(755,root,root) %{extdir}/pdo_pgsql.so
%attr(644,root,root) %{_sysconfdir}/php.d/apache/pgsql.ini
%attr(644,root,root) %{_sysconfdir}/php.d/cli/pgsql.ini

%changelog
* Mon Jun 20 2016 JoungKyun.Kim <http://oops.org> 1:7.0.7-1%{?dist}
- security issues
  . CVE-2016-3074 libgd: signedness vulnerability (#71912)
  . CVE-2016-3078 integer overflow in ZipArchive::getFrom* (#71923)

- fixed zend_mm_heap corrupted problems of exec_dir patch

- official 7.0.7 bug fixed
  . fixed #72221 Core: segfault, past-the-end access
  . fixed #72218 Core: If host name cannot be resolved then PHP 7 crashes
  . fixed #72308 FPM: fastcgi_finish_request and logging environment variables
  . fixed #72337 GD: invalid dimensions can lead to crash
  . fixed #72143 PCRE: preg_replace uses int instead of size_t
  . fixed #71573 PDO_pgsql: Segfault (core dumped) if paramno beyond bound
  . fixed #72294 PDO_pgsql: Segmentation fault/invalid pointer in connection with pgsql_stmt_dtor
  . fixed #72284 Phpdbg: phpdbg fatal errors with coverage
  . fixed #72195 Postgres: pg_pconnect/pg_connect cause use-after-free
  . fixed #72197 Postgres: pg_lo_create arbitrary read
  . fixed #72206 XML: xml_parser_create/xml_parser_free leaks mem
  . fixed #72369 Standard: array_merge() produces references in PHP7
  . fixed #72017 Standard: range() with float step produces unexpected result
  . fixed #72229 Standard: Wrong reference when serialize/unserialize an object
  . fixed #72300 Standard: ignore_user_abort(false) has no effect
  . fixed #72258 Zip: ZipArchive converts filenames to unrecoverable form

- official 7.0.8 bug fixed
  . fixed #43475 GD: Thick styled lines have scrambled patterns
  . fixed #53640 GD: XBM images require width to be multiple of 8
  . fixed #72399 Mbstring: Use-After-Free in MBString (search_re)
  . fixed #72405 Mbstring: mb_ereg_replace - mbc_to_code (oniguruma) - oob read access
  . fixed #72306 Standard: Heap overflow through proc_open and $env parameter
  . fixed #72439 Stream: Stream socket with remote address leads to a segmentation fault

* Wed Mar 23 2016 JoungKyun.Kim <http://oops.org> 1:7.0.4-1%{?dist}
- security issues
  . CVE-2016-3185 #71610 Soap: Type Confusion Vulnerability - SOAP / make_http_soap_request()

- official 7.0.4 bug fixed
  . fixed bug #69953 CLI Server: Support MKCALENDAR request method
  . fixed bug #71624 Core: `php -R` (PHP_MODE_PROCESS_STDIN) is broken
  . fixed bug #71806 Core: php_strip_whitespace() fails on some numerical values
  . fixed bug #71767 Core: ReflectionMethod::getDocComment returns the wrong comment
  . fixed bug #71724 Core: yield from does not count EOLs
  . Fixed bug #71575 Core: ISO C does not allow extra ‘;’ outside of a function
  . fixed bug #71470 Core: Leaked 1 hashtable iterators
  . fixed bug #71535 Core: Integer overflow in zend_mm_alloc_heap()
  . fixed bug #71596 Core: Segmentation fault on ZTS with date function (setlocale)
  . fixed bug #71622 Core: Strings used in pass-as-reference cannot be used to invoke C::$callable()
  . fixed bug #71629 Core: Out-of-bounds access in php_url_decode in context php_stream_url_wrap_rfc2397
  . fixed bug #71695 Core: Global variables are reserved before execution
  . fixed bug #71729 Core: Possible crash in zend_bin_strtod, zend_oct_strtod, zend_hex_strtod
  . fixed bug #71756 Core: Call-by-reference widens scope to uninvolved functions when used in switch
  . fixed bug #71694 Curl: Support constant CURLM_ADDED_ALREADY
  . fixed bug #71635 Date: DatePeriod::getEndDate segfault
  . fixed bug #71536 libxml: Access Violation crashes php-cgi.exe
  . fixed bug #47803, #69526 ODBC: Executing prepared statements is succesfull only for the first two statements
  . fixed bug #71659 PCRE: segmentation fault in pcre running twig tests
  . fixed bug #71625 Phar: Crash in php7.dll with bad phar filename
  . fixed bug #71317 Phar: PharData fails to open specific file
  . fixed Bug #71683 Session: Null pointer dereference in zend_hash_str_find_bucket
  . fixed bug #71617 SPL: private properties lost when unserializing ArrayObject
  . fixed bug #71660 Standard: array_column behaves incorrectly after foreach by reference

- official 7.0.5 bug fixed
  . fixed bug #71841 Core: EG(error_zval) is not handled well
  . fixed bug #71731 Core: Null coalescing operator and ArrayAccess
  . fixed bug #69659 Core: ArrayAccess, isset() and the offsetExists method
  . fixed bug #62059 Core: ArrayObject and isset are not friends
  . fixed bug #71871 Core: Interfaces allow final and abstract functions
  . fixed Bug #71859 Core: zend_objects_store_call_destructors operates on realloced memory, crashing
  . fixed bug #71750 Core: Multiple Heap Overflows in php_raw_url_encode/php_url_encode
  . fixed bug #71840 Standard: Unserialize accepts wrongly data
  . fixed bug #71837 Standard: Wrong arrays behaviour
  . fixed bug #71831 Curl: CURLOPT_NOPROXY applied as long instead of string
  . fixed bug #63171 ODBC: Script hangs after max_execution_time
  . fixed bug #71843 Opcache: null ptr deref ZEND_RETURN_SPEC_CONST_HANDLER
  . fixed bug #52098 PDO: Own PDOStatement implementation ignore __call()
  . fixed bug #71820 Postgres: pg_fetch_object binds parameters before call constructor
  . fixed bug #71838 SPL: Deserializing serialized SPLObjectStorage-Object can't access properties in PHP
  . fixed bug #52339 SPL: SPL autoloader breaks class_exists()
  . fixed bug #67582 SPL: Cloned SplObjectStorage with overwritten getHash fails offsetExists()
  . fixed bug #71735 SPL: Double-free in SplDoublyLinkedList::offsetSet

* Mon Feb 15 2016 JoungKyun.Kim <http://oops.org> 1:7.0.3-1%{?dist}
- security fixed
  . CVE-2015-8383
  . CVE-2015-8386
  . CVE-2015-8387
  . CVE-2015-8389
  . CVE-2015-8390
  . CVE-2015-8391
  . CVE-2015-8393
  . CVE-2015-8394
- offcial bug fixed
  . fixed bug #71485 Core: Return typehint on interanal func causes Fatal error when it throws exception
  . fixed bug #71474 Core: Crash because of VM stack corruption on Magento2
  . fixed bug #71450 Core: An integer overflow bug in php_str_to_str_ex()
  . fixed bug #71449 Core: An integer overflow bug in php_implode()
  . fixed bug #71443 Core: Segfault using built-in webserver with intl using symfony
  . fixed bug #71442 Core: forward_static_call crash
  . fixed bug #71441 Core: Typehinted Generator with return in try/finally crashes
  . fixed bug #71529 Core: Variable references on array elements don't work when using count
  . fixed bug #71525 Date: Calls to date_modify will mutate timelib_rel_time, causing date_date_set issues
  . fixed bug #71269 FPM: php-fpm dumped core
  . fixed bug #71584 Opcache: Possible use-after-free of ZCG(cwd) in Zend Opcache
  . fixed bug #71537 PCRE: PCRE segfault from Opcache
  . fixed bug #71523 CURL: Copied handle with new option CURLOPT_HTTPHEADER crashes while curl_multi_exec
  . fixed memory leak in curl_getinfo()
  . fixed bug #71434 Fileinfo: finfo throws notice for specific python file
  . fixed bug #62172 FPM: FPM not working with Apache httpd 2.4 balancer/fcgi setup
  . fixed inherited functions from unspecified files being included in phpdbg_get_executable()
  . fixed bug #70720 Standard: strip_tags improper php code parsing
  . fixed bug #71501 XMLRPC: xmlrpc_encode_request ignores encoding option
  . fixed bug #71561 Zip: NULL pointer dereference in Zip::ExtractTo
- fixed malform free on zend_destory_list_tables

* Thu Jan 28 2016 JoungKyun.Kim <http://oops.org> 1:7.0.2-4%{?dist}
- official bug fixed
  . fixed bug #71442 Core: forward_static_call crash
  . fixed bug #71443 Core: Segfault using built-in webserver with intl using symfony
  . fixed bug #71449 Core: An integer overflow bug in php_implode()
  . fixed bug #71450 Core: An integer overflow bug in php_str_to_str_ex()
  . fixed bug #71434 Fileinfo: finfo throws notice for specific python file
- fixed segfault libevent

* Mon Jan 25 2016 JoungKyun.Kim <http://oops.org> 1:7.0.2-3%{?dist}
- fixed wrong build with ZTS
- official bug fixed
  . fixed bug #71397 mbstring: mb_send_mail segmentation fault
  . fixed bug #71441 Core: Typehinted Generator with return in try/finally crashes

* Mon Jan 18 2016 JoungKyun.Kim <http://oops.org> 1:7.0.2-2%{?dist}
- official bug fixed
  . fixed bug #71336 Core: Wrong is_ref on properties as exposed via get_object_vars()
  . fixed bug #71248 Core: Wrong interface is enforced
  . fixed bug #70979 Soap: crash with bad soap request
  . Improved fix for bug #68063 Session:Empty session IDs do still start sessions
  . Fixed bug #69111 Session: Crash in SessionHandler::read()
  . Fixed bug #71038 Session: session_start() returns TRUE on failure
  . Fixed bug #71394 Session: session_regenerate_id() must close opened session on errors
  . fixed bug #71132, #71197 Standard: range() segfaults
  . fixed bug #70879 Apache2handler: Content-Length with apache2handler may be limited to 2G
- add mysql extension

* Fri Jan  8 2016 JoungKyun.Kim <http://oops.org> 1:7.0.2-1%{?dist}
- update 7.0.2
  . Fixed bug #71300 Core: Segfault in zend_fetch_string_offset
  . Fixed bug #71221 Core: Null pointer deref (segfault) in get_defined_vars via ob_start
  . Fixed bug #71201 Core: round() segfault on 64-bit builds
  . Core: support for new HTTP 451 code
  . Fixed Bug #71275 Core: Bad method called on cloning an object having a trait
  . Fixed bug #71273 Core: A wrong ext directory setup in php.ini leads to crash
  . Fixed bug #71297 Core: Memory leak with consecutive yield from
  . Fixed bug #71314 Core: var_export(INF) prints INF.0
  . Fixed bug #71227 Curl: Can't compile php_curl statically
  . Fixed bug #71225 Curl: curl_setopt() fails to set CURLOPT_POSTFIELDS with reference to CURLFile
  . Fixed bug #71249 Ldap: ldap_mod_replace/ldap_mod_add store value as string "Array"
  . Fixed bug #71202 SPL: Autoload function registered by another not activated immediately
  . Fixed bug #71204 SPL: segfault if clean spl_autoload_funcs while autoloading
  . Fixed bug #71287 Standard: Error message contains hexadecimal instead of decimal number
  . Fixed bug #71264 Standard: file_put_contents() returns unexpected value when filesystem runs full
  . Fixed bug #71245 Standard: file_get_contents() ignores "header" context option if it's a reference
  . Fixed bug #71220 Standard: Null pointer deref (segfault) in compact via ob_start
  . Fixed bug #71190 Standard: substr_replace converts integers in original $search array to strings
  . Fixed bug #71188 Standard: str_replace converts integers in original $search array to strings
  . Fixed bug #70720 Standard: strip_tags improper php code parsing

* Fri Jan  8 2016 JoungKyun.Kim <http://oops.org> 1:7.0.1-1%{?dist}
- update 7.0.1
- official bug fixed
  . Fixed bug #71165 Core: -DGC_BENCH=1 doesn't work on PHP7
  . Fixed bug #71163 Core: Segmentation Fault: cleanup_unfinished_calls
  . Fixed bug #71109 Core: ZEND_MOD_CONFLICTS("xdebug") doesn't work
  . Fixed bug #71092 Core: Segmentation fault with return type hinting
  . Fixed bug Core: memleak in header_register_callback
  . Fixed bug #71067 Core: Local object in class method stays in memory for each call
  . Fixed bug #66909 IMAP: configure fails utf8_to_mutf7 test
  . Fixed bug #70781 Core: Extension tests fail on dynamic ext dependency
  . Fixed bug #71089 Core: No check to duplicate zend_extension
  . Fixed bug #71086 Core: Invalid numeric literal parse error within highlight_string() function
  . Fixed bug #71154 Core: Incorrect HT iterator invalidation causes iterator reuse
  . Fixed bug #52355 Core: Negating zero does not produce negative zero
  . Fixed bug #66179 Core: var_export() exports float as integer
  . Fixed bug #70804 Core: Unary add on negative zero produces positive zero
  . Fixed bug #71144 CURL: Sementation fault when using cURL with ZTS
  . DBA: Fixed key leak with invalid resource
  . Fixed bug #71063 Filter: filter_input(INPUT_ENV, ..) does not work
  . Implemented FR #55651 FTP: Option to ignore the returned FTP PASV address
  . Fixed bug #71066 Mbstring: mb_send_mail: Program terminated with signal SIGSEGV, Segmentation fault
  . Fixed bug #71127 Opcache: Define in auto_prepend_file is overwrite
  . Fixed bug #71178 PCRE: preg_replace with arrays creates [0] in replace array if not already set
  . Fixed bug #71094 Readline: readline_completion_function corrupts static array on second TAB
  . Fixed bug #71122 Session: Session GC may not remove obsolete session data
  . Fixed bug #71077 SPL: ReflectionMethod for ArrayObject constructor returns wrong number of parameters
  . Fixed bug #71153 SPL: Performance Degradation in ArrayIterator with large arrays

- 3rd parth support
  . libevent, ncurses

